// Todd Rhoades
// CPS 406
// September 30, 1999
// FILE: Starburst.java

// NOTE: all classes and methods were written by myself

import java.awt.*;

//////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Class Starburst - Used to contain a singls Starburst.  It contains information about the center
// position of the starburst, its color, and a size limit.  It also holds the current size of the
// starburst.  In addition, it contains methods for manipulating a starburst.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

public class Starburst {
	private int centerXPos;  // The x position of the center of the starburst
	private int centerYPos;  // The y position of the center of the starburst
	private int distanceFromCenter;  // The current distance of the starburst ring from its center
	private int limit;  // The maximum limit of the distance from the center
	private Color burstColor;  // The color of the starburst
	
	// Starburst constructor which accepts the center coordinates of the starburst, the initial
	// distance of the ring from the center, and the maximum distance allowed
	public Starburst(int cx, int cy, int d, int l) {
		centerXPos = cx;
		centerYPos = cy;
		distanceFromCenter = d;
		limit = l;
	}
	
	// Method setColor which sets the color of the starburst(access method)
	public void setColor(Color c) {
		burstColor = c;
	}
	
	// Method reachedLimit which returns true if the distance of the ring from its center has reached
	// the maximum distance
	public boolean reachedLimit() {
		if(distanceFromCenter == limit) {
			return true;
		}
		else {
			return false;
		}
	}
	
	// Method expand which simply increases the distance of the ring from its center by one
	public void expand() {
		distanceFromCenter++;
	}
	
	// Method paint to paint the starburst on the offscreen buffer for display
	public void paint(Graphics g) {
		int x;
		int y;
		g.setColor(burstColor);
		
		// Draw each point in the starburst ring as a rectangle of length 2 and width 2
		for (int i = 0; i < 16; i++) {
			x = (int)(centerXPos + distanceFromCenter * Math.cos (i * 2 * Math.PI / 16));
			y = (int)(centerYPos + distanceFromCenter * Math.sin (i * 2 * Math.PI / 16));
		    g.drawRect(x, y, 2, 2);
		}
	}
}